package eu.jonahbauer.wizard.client.libgdx.actions;

import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.scenes.scene2d.Action;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.utils.Pool;
import com.badlogic.gdx.utils.Pools;
import lombok.Setter;

public class ChangeParentAction extends Action {
    private Vector2 pos;

    @Setter
    private Group parent;
    private boolean finished;

    public boolean act(float delta) {
        if (pos == null) pos = new Vector2();
        if (!finished) {
            finished = true;
            pos.set(target.getX(), target.getY());
            target.parentToLocalCoordinates(pos);
            target.localToStageCoordinates(pos);
            parent.stageToLocalCoordinates(pos);
            target.setPosition(pos.x, pos.y);
            parent.addActor(target);
        }
        return true;
    }

    public void restart () {
        finished = false;
    }
}
