package eu.jonahbauer.wizard.client.libgdx.screens;

import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import eu.jonahbauer.wizard.client.libgdx.UiskinAtlas;
import eu.jonahbauer.wizard.client.libgdx.WizardGame;

public abstract class MenuScreen extends WizardScreen {
    protected final float BUTTON_BAR_Y = WizardGame.HEIGHT * 0.15f;

    private Image[] corners;

    public MenuScreen(WizardGame game) {
        super(game);
    }

    @Override
    public void show() {
        super.show();

        corners = new Image[4];
        corners[0] = new Image(skin.get(UiskinAtlas.CORNER_TOP_LEFT, TextureRegion.class));
        corners[1] = new Image(skin.get(UiskinAtlas.CORNER_BOTTOM_LEFT, TextureRegion.class));
        corners[2] = new Image(skin.get(UiskinAtlas.CORNER_BOTTOM_RIGHT, TextureRegion.class));
        corners[3] = new Image(skin.get(UiskinAtlas.CORNER_TOP_RIGHT, TextureRegion.class));
        for (var corner : corners) {
            stage.addActor(corner);
        }

        var title = new Image(skin.get(UiskinAtlas.TITLE, TextureRegion.class));
        title.setSize(810, 192);
        title.setPosition(555, WizardGame.HEIGHT - 192 - 96);
        stage.addActor(title);
    }

    @Override
    public void resize(int width, int height) {
        super.resize(width, height);

        var worldWidth = viewport.getWorldWidth();
        var worldHeight = viewport.getWorldHeight();
        var offsetX = (worldWidth - WizardGame.WIDTH) / 2;
        var offsetY = (worldHeight - WizardGame.HEIGHT) / 2;

        corners[0].setPosition(- offsetX, worldHeight - corners[0].getHeight() - offsetY);
        corners[1].setPosition(- offsetX, - offsetY);
        corners[2].setPosition(worldWidth - corners[2].getWidth() - offsetX, - offsetY);
        corners[3].setPosition(worldWidth - corners[3].getWidth() - offsetX, worldHeight - corners[3].getHeight() - offsetY);
    }
}
